
angular.module('tamkEvents').controller('OrganizationsModalCtrl', function ($scope, $rootScope, OrganizerService, $ionicLoading) {
    function refreshList(data) {
        $scope.organizers = [];

        data.forEach(function (organizer) {
            if (organizer.type === 0) {
                organizer.selected = $rootScope.organizations.indexOf(organizer.id) !== -1;

                $scope.organizers.push(organizer);
            }
        });
    }

    refreshList($rootScope.filterCache.organizers);

    // Refresh list of organizers after a few milliseconds so the animation doesn't get laggy.
    setTimeout(function () {
        OrganizerService.getOrganizers(0, function (err, organizers) {
            if (!err) {
                refreshList(organizers);
            }
        });
    }, 400);

    $scope.save = function () {
        var chosen = [];

        $scope.organizers.forEach(function (item) {
            if (item.selected) {
                chosen.push(item.id);
            }
        });

        localStorage.organizations = JSON.stringify(chosen);

        $scope.close();
    };

    $scope.close = function () {
        $rootScope.$broadcast("organizations-saved");
    };
});