angular.module('tamkEvents').controller('TagsModalCtrl', function ($scope, $rootScope, TagService, $ionicLoading) {
    function refreshList(data) {
        $scope.tags = [];
        data.forEach(function (tag) {
            tag.selected = $rootScope.tags.indexOf(tag.id) !== -1;

            $scope.tags.push(tag);
        });
    }

    refreshList($rootScope.filterCache.tags);

    // Refresh list of tags after a few milliseconds so the animation doesn't get laggy.
    setTimeout(function () {
        TagService.getTags(function (err, tags) {
            if (!err) {
                refreshList(tags);
            }
        });
    }, 400);

    $scope.save = function () {
        var chosen = [];

        $scope.tags.forEach(function (item) {
            if (item.selected) {
                chosen.push(item.id);
            }
        });

        localStorage.tags = JSON.stringify(chosen);

        $scope.close();
    };

    $scope.close = function () {
        $rootScope.$broadcast("tags-saved");
    };
});