(function () {
    "use strict";

    var app = angular.module('tamkEvents');

    app.factory("EventService", ["$rootScope", "$resource", "$translate",
        function ($rootScope, $resource, $translate) {
            var services = {
                getEvents: function (query, callback) {

                    var searchString = "http://tamkevents.com/api/public/events/?";
                    query.key = "paprika";
                    query.language = $translate.proposedLanguage();

                    Object.keys(query).forEach(function (key, index) {
                        if (query[key] !== "" && query[key] !== undefined) {
                            searchString += (index === 0 ? "":"&") + key + "=:" + key;
                        } else {
                            delete query[key];
                        }
                    });

                    var result = $resource(searchString);

                    var root = result.get(
                        query,
                        function () {
                            callback(null, root.result);
                        }, function (err) {
                            $rootScope.$broadcast("http-error", err);
                            callback(err);
                        });
                },

                getEvent: function (id, callback) {
                    var searchString = "http://tamkevents.com/api/public/events/:id" +
                        "?key=:key&language=:language";
                    var result = $resource(searchString);

                    var root = result.get({
                        key: "paprika",
                        language: $translate.proposedLanguage(),
                        id: id
                    }, function () {
                        callback(null, root.result);
                    }, function (err) {
                        $rootScope.$broadcast("http-error", err);
                        callback(err)
                    });
                }
            };

            return services;
        }]);
}());