(function () {
    "use strict";

    var app = angular.module('tamkEvents');

    app.factory("OrganizerService", ["$rootScope", "$resource", "$translate",
        function ($rootScope, $resource, $translate) {
            return {
                getOrganizers: function (type, callback) {
                    var searchString = "http://tamkevents.com/api/public/organizers/" +
                        "?key=:key&language=:language";

                    var query = {
                        key: "paprika",
                        language: $translate.proposedLanguage()
                    };

                    if (type) {
                        searchString += "&type=:type";
                        query.type = type;
                    }

                    var result = $resource(searchString);

                    var root = result.get(query, function () {
                        callback(null, root.result);
                    }, function (err) {
                        $rootScope.$broadcast("http-error", err);
                        callback(err);
                    });
                }
            };
        }]);
}());